'use strict';

var net = require('net');

var Transceiver = require('./serial-proxy/transceiver');

var STD_OUT = 1;
var PORT = 7883;

var transceiver = new Transceiver();

var proxied = false;

next();

function next() {
    var client = net.connect(PORT, '127.0.0.1', function () {
        if (proxied) {
            return;
        }

        proxied = true;
        uv.fs_write(STD_OUT, '[serial-proxy-success]', -1);
    });

    client.on('data', function (data) {
        transceiver.send(data);
    });

    client.on('close', function () {
        transceiver.removeAllListeners();
        next();
    });

    transceiver.on('data', forwardData);
    transceiver.on('error', function () { });

    function forwardData(data) {
        client.write(data);
    }
}
